Option Explicit On 
Option Strict On
Option Compare Binary

Imports Microsoft.CSharp
Imports Microsoft.VisualBasic
Imports System
Imports System.CodeDom.Compiler
Imports System.Diagnostics
Imports System.Reflection
Imports System.Windows.Forms

' <remarks>
'   Hauptformular der Anwendung.
' </remarks>
Public Class MainForm
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "
    Public Sub New()
        MyBase.New()
        InitializeComponent()

        ' Anpassen der Controls.
        With Me.cboLanguage
            .Items.Add("Visual Basic .NET")
            .Items.Add("C#")
            .SelectedIndex = 0
        End With
        Me.txtApplicationName.Text = Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\MyTest.exe"
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents btnCompileAndRun As System.Windows.Forms.Button
    Friend WithEvents cboLanguage As System.Windows.Forms.ComboBox
    Friend WithEvents txtSource As System.Windows.Forms.TextBox
    Friend WithEvents txtApplicationName As System.Windows.Forms.TextBox
    Friend WithEvents txtMainClassName As System.Windows.Forms.TextBox
    Friend WithEvents chkIncludeDebugInfo As System.Windows.Forms.CheckBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label

    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.btnCompileAndRun = New System.Windows.Forms.Button()
        Me.txtSource = New System.Windows.Forms.TextBox()
        Me.cboLanguage = New System.Windows.Forms.ComboBox()
        Me.txtApplicationName = New System.Windows.Forms.TextBox()
        Me.txtMainClassName = New System.Windows.Forms.TextBox()
        Me.chkIncludeDebugInfo = New System.Windows.Forms.CheckBox()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.Label4 = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'btnCompileAndRun
        '
        Me.btnCompileAndRun.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.btnCompileAndRun.Location = New System.Drawing.Point(144, 336)
        Me.btnCompileAndRun.Name = "btnCompileAndRun"
        Me.btnCompileAndRun.Size = New System.Drawing.Size(160, 24)
        Me.btnCompileAndRun.TabIndex = 9
        Me.btnCompileAndRun.Text = "&Kompilieren und ausfhren"
        '
        'txtSource
        '
        Me.txtSource.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtSource.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtSource.Location = New System.Drawing.Point(16, 120)
        Me.txtSource.Multiline = True
        Me.txtSource.Name = "txtSource"
        Me.txtSource.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtSource.Size = New System.Drawing.Size(416, 192)
        Me.txtSource.TabIndex = 8
        Me.txtSource.Text = "Option Explicit On" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "Option Strict On" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "Imports System.Windows.Forms" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "Imports Sys" & _
        "tem" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "Public Class Main" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "    Public Shared Sub Main()" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "        Console.WriteLin" & _
        "e(""Hello World!"")" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "        MessageBox.Show(""Hello World!"")" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "    End Sub" & Microsoft.VisualBasic.ChrW(13) & Microsoft.VisualBasic.ChrW(10) & "End Cla" & _
        "ss"
        '
        'cboLanguage
        '
        Me.cboLanguage.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboLanguage.Location = New System.Drawing.Point(16, 32)
        Me.cboLanguage.Name = "cboLanguage"
        Me.cboLanguage.Size = New System.Drawing.Size(200, 21)
        Me.cboLanguage.TabIndex = 1
        '
        'txtApplicationName
        '
        Me.txtApplicationName.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtApplicationName.Location = New System.Drawing.Point(232, 32)
        Me.txtApplicationName.Name = "txtApplicationName"
        Me.txtApplicationName.Size = New System.Drawing.Size(200, 20)
        Me.txtApplicationName.TabIndex = 4
        Me.txtApplicationName.Text = ""
        '
        'txtMainClassName
        '
        Me.txtMainClassName.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtMainClassName.Location = New System.Drawing.Point(232, 72)
        Me.txtMainClassName.Name = "txtMainClassName"
        Me.txtMainClassName.Size = New System.Drawing.Size(200, 20)
        Me.txtMainClassName.TabIndex = 6
        Me.txtMainClassName.Text = "Main"
        '
        'chkIncludeDebugInfo
        '
        Me.chkIncludeDebugInfo.Location = New System.Drawing.Point(16, 64)
        Me.chkIncludeDebugInfo.Name = "chkIncludeDebugInfo"
        Me.chkIncludeDebugInfo.Size = New System.Drawing.Size(184, 16)
        Me.chkIncludeDebugInfo.TabIndex = 2
        Me.chkIncludeDebugInfo.Text = "&Debug-Informationen erstellen"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(232, 56)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(128, 16)
        Me.Label1.TabIndex = 5
        Me.Label1.Text = "&Name der Hauptklasse:"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(232, 16)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(128, 16)
        Me.Label2.TabIndex = 3
        Me.Label2.Text = "&Anwendungsname:"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(16, 16)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(128, 16)
        Me.Label3.TabIndex = 0
        Me.Label3.Text = "&Programmiersprache:"
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(16, 104)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(128, 16)
        Me.Label4.TabIndex = 7
        Me.Label4.Text = "&Quellcode:"
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(448, 376)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Label4, Me.Label3, Me.Label2, Me.Label1, Me.chkIncludeDebugInfo, Me.txtMainClassName, Me.txtApplicationName, Me.cboLanguage, Me.txtSource, Me.btnCompileAndRun})
        Me.MinimumSize = New System.Drawing.Size(456, 410)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "DotNetCompiler"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Private Sub btnCompileAndRun_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnCompileAndRun.Click

        ' Benutzereingaben prfen.
        If Me.txtApplicationName.TextLength = 0 Then
            MessageBox.Show("Der Anwendungsname darf nicht leer sein!", _
                Application.ProductName, _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
            Return
        ElseIf Me.txtMainClassName.TextLength = 0 Then
            MessageBox.Show("Der Name der Hauptklasse darf nicht leer sein!", _
                Application.ProductName, _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
            Return
        End If

        ' Je nach Einstellung fr VB .NET oder C# kompilieren.
        Dim cdp As CodeDomProvider
        If Me.cboLanguage.SelectedIndex = 0 Then
            cdp = New VBCodeProvider()
        Else
            cdp = New CSharpCodeProvider()
        End If

        ' Konfigurieren des Compilers.
        Dim compiler As ICodeCompiler = cdp.CreateCompiler()
        Dim cpParameters As CompilerParameters = New CompilerParameters()
        With cpParameters
            .GenerateExecutable = True
            .OutputAssembly = Me.txtApplicationName.Text
            .MainClass = Me.txtMainClassName.Text
            .IncludeDebugInformation = chkIncludeDebugInfo.Checked

            ' Verfgbare Assemblies hinzufgen. Fr unsere einfache
            '  Anwendung sollte dies ausreichend sein.
            Dim asm As [Assembly]
            For Each asm In AppDomain.CurrentDomain.GetAssemblies()
                .ReferencedAssemblies.Add(asm.Location)
            Next asm
        End With

        ' Kompilieren der Assembly.
        Dim strCode As String = Me.txtSource.Text
        Dim cr As CompilerResults = _
            compiler.CompileAssemblyFromSource(cpParameters, strCode)

        If cr.Errors.Count > 0 Then
            Dim strErrors As String = _
                "Kompilierung ist fehlgeschlagen" & ControlChars.NewLine
            Dim cerr As CompilerError
            For Each cerr In cr.Errors
                strErrors &= ControlChars.NewLine & cerr.ToString()
            Next cerr

            MessageBox.Show(strErrors, _
                Application.ProductName, _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
            Return
        End If

        ' Kompilierung war erfolgreich, versuche die erstellte Anwendung 
        ' auszufhren.
        Try
            If Not System.IO.File.Exists(Me.txtApplicationName.Text) Then
                MessageBox.Show( _
                    String.Format("Die Datei ""{0}"" kann nicht gefunden " & _
                        "und daher auch nicht ausgefhrt werden!", _
                    Me.txtApplicationName.Text), _
                    Application.ProductName, _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Exclamation)
                Return
            End If

            Dim psi As ProcessStartInfo = _
                New ProcessStartInfo(Me.txtApplicationName.Text)
            Process.Start(psi)
        Catch ex As Exception
            MessageBox.Show( _
                String.Format("Fehler beim Ausfhren von ""{0}""!", _
                Me.txtApplicationName.Text), _
                Application.ProductName, _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
        End Try
    End Sub
End Class